"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var inflector_js_1 = __importDefault(require("inflector-js"));
var react_1 = __importDefault(require("react"));
var rxjs_1 = require("rxjs");
var components_1 = require("./../../../components");
var reactive_1 = require("./../../../reactive");
var rels_1 = __importDefault(require("./../../../stream-store/rels"));
var store_1 = __importDefault(require("./../../../stream-store/store"));
var utils_1 = require("./../../../utils");
var provider$ = store_1.default.hal$.body$.map(function (_a) {
    var provider = _a.provider;
    return provider;
});
var versions$ = store_1.default.hal$.body$.map(function (_a) {
    var versions = _a.versions;
    return versions;
});
var info$ = provider$.zip(versions$).map(function (_a) {
    var _b = __read(_a, 2), provider = _b[0], versions = _b[1];
    return [
        {
            id: 'Provider',
            value: inflector_js_1.default.camel2words(inflector_js_1.default.underscore(provider)),
        },
    ]
        .concat(Object.keys(versions).map(function (key) { return ({
        id: inflector_js_1.default.camel2words(inflector_js_1.default.underscore(key)) + " Version",
        value: versions[key],
    }); }))
        .concat({
        id: 'Client Version',
        value: utils_1.clientVersion,
    });
});
var recent$ = store_1.default.hal$.body$.map(function (_a) {
    var _b = _a._embedded, _embedded = _b === void 0 ? {} : _b;
    return _embedded[rels_1.default.feed];
});
var state$ = reactive_1.createState(rxjs_1.Observable.merge(info$.map(function (info) { return ['info', function () { return info; }]; }), recent$.map(function (recent) { return ['recent', function () { return recent; }]; })), rxjs_1.Observable.of({ recent: [], info: [] }));
var InfoLine = function (_a) {
    var id = _a.id, value = _a.value;
    return (react_1.default.createElement(components_1.Table.Row, null,
        react_1.default.createElement(components_1.Table.Cell, null,
            react_1.default.createElement("strong", null, id)),
        react_1.default.createElement(components_1.Table.Cell, null, value)));
};
var Info = function (_a) {
    var info = _a.info;
    return (react_1.default.createElement(components_1.Table, null,
        react_1.default.createElement(components_1.Table.Head, null,
            react_1.default.createElement(components_1.Table.Row, null,
                react_1.default.createElement(components_1.Table.Cell, { colSpan: 2 }, 'Server Information'))),
        react_1.default.createElement(components_1.Table.Body, null, info.map(function (_a) {
            var id = _a.id, value = _a.value;
            return (react_1.default.createElement(InfoLine, { key: id, id: id, value: value }));
        }))));
};
var Index = function (_a) {
    var info = _a.info;
    return (react_1.default.createElement("section", null,
        react_1.default.createElement(Info, { info: info })));
};
exports.default = reactive_1.connect(state$)(Index);
