"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var mediaTypes_1 = __importDefault(require("./mediaTypes"));
var isJson = function (mediaType) {
    return mediaType === mediaTypes_1.default.json || (mediaType || '').endsWith('+json');
};
var getBody = function (response, headers) { return __awaiter(_this, void 0, void 0, function () {
    var body;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, response.text()];
            case 1:
                body = _a.sent();
                if (!isJson(headers['content-type'])) {
                    return [2 /*return*/, body];
                }
                try {
                    return [2 /*return*/, JSON.parse(body)];
                }
                catch (e) {
                    return [2 /*return*/, {}];
                }
                return [2 /*return*/];
        }
    });
}); };
var createRequestHeaders = function (headers) {
    return new Headers(Object.keys(headers)
        .filter(function (key) { return headers[key]; })
        .reduce(function (akk, key) {
        var _a;
        return (__assign({}, akk, (_a = {}, _a[key] = headers[key], _a)));
    }, {}));
};
var getResponseHeaders = function (headers) {
    return __spread(headers.entries()).reduce(function (acc, _a) {
        var _b = __read(_a, 2), key = _b[0], value = _b[1];
        var _c;
        return value
            ? __assign({}, acc, (_c = {}, _c[key] = value, _c)) : acc;
    }, {});
};
var mapResponse = function (response) { return __awaiter(_this, void 0, void 0, function () {
    var ok, status, statusText, url, headers, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                ok = response.ok, status = response.status, statusText = response.statusText, url = response.url;
                headers = getResponseHeaders(response.headers);
                _a = {};
                return [4 /*yield*/, getBody(response, headers)];
            case 1: return [2 /*return*/, (_a.body = _b.sent(),
                    _a.headers = headers,
                    _a.ok = ok,
                    _a.status = status,
                    _a.statusText = statusText,
                    _a.url = url,
                    _a)];
        }
    });
}); };
var get = function (_a) {
    var link = _a.link, _b = _a.headers, headers = _b === void 0 ? {} : _b;
    return fetch(link.href, {
        credentials: 'same-origin',
        headers: createRequestHeaders(__assign({ accept: link.type || mediaTypes_1.default.any }, headers)),
    }).then(mapResponse);
};
var post = function (_a) {
    var link = _a.link, body = _a.body, _b = _a.headers, headers = _b === void 0 ? {} : _b;
    return fetch(link.href, {
        body: JSON.stringify(body),
        credentials: 'same-origin',
        headers: createRequestHeaders(__assign({ accept: link.type || mediaTypes_1.default.any, 'content-type': mediaTypes_1.default.json }, headers)),
        method: 'post',
    }).then(mapResponse);
};
var _delete = function (_a) {
    var link = _a.link, _b = _a.headers, headers = _b === void 0 ? {} : _b;
    return fetch(link.href, {
        credentials: 'same-origin',
        headers: createRequestHeaders(__assign({ accept: link.type || mediaTypes_1.default.any }, headers)),
        method: 'delete',
    }).then(mapResponse);
};
var http = {
    delete: _delete,
    get: get,
    post: post,
};
exports.default = http;
